#include <bits/stdc++.h>

using namespace std;

long long int a[200001];
long long int pom;
long int k,n;
int main()
{
    
    scanf("%ld%ld",&n,&k);
    for(long long int i=0;i<n;i++)
    {
        scanf("%lld",&pom);
        if(i==0) a[i]=pom;
        else a[i]=a[i-1]+pom;
        a[i]=a[i]%1000000007;
    }
    if(k==0) printf("%lld",a[n-1]);
    else if(k==1)
    {
        pom=0;
        for(long int i=0;i<n;i++)
        {
            for(long int j=i;j<n;j++)
            {
                if(i==0) pom+=a[j];
                else pom+=a[j]-a[i-1];
                pom=pom%1000000007;
            }
        }
        printf("%lld",pom);
    }
    return 0;
}